#include <iostream.h>
#include <fstream.h>
#include <string.h>
#include <stdlib.h>

char type[][21] = {"286", "386SX", "386DX2", "486DX2", "Pentium", "Pentium MMX", "Pentium Pro", "Pentium II"};
int speed[] = {12, 33, 40, 60, 66, 75, 90, 120, 133, 150, 166, 180, 200, 233, 266};
int mem[] = {1, 4, 8, 16, 24, 32, 40, 64, 96};
int hdd[] = {40, 200, 540, 850, 1300, 1600, 2000, 2100, 4300};
char video[][21] = {"CGA", "EGA", "Hercules", "Avance Logic", "Cirrus Logic", "Paradize", "Diamond Stealth", "S3 Virge", "S3 Trio64 V+", "Turtle Beach"};

struct record {
  char processor[16];
  int  speed;
  int  memory;
  int  HDD;
  char video[18];
  int price;
} r;

void Generate()
{
  int a, b, c, d, e;
  a = random(8);
  b = random(15);
  c = random(9);
  d = random(9);
  e = random(10);
  strcpy(r.processor, "\"");
  strcat(r.processor, type[a]);
  strcat(r.processor, "\"");
  r.speed = speed[b];
  r.memory = mem[c];
  r.HDD = hdd[d];
  strcpy(r.video, "\"");
  strcat(r.video, video[e]);
  strcat(r.video, "\"");
  r.price = (a + 1) * 115 + (b + 1) * 20 + (c + 1) * 35 + (d + 1) * 40 + (e + 1) * 30;
}

void main()
{
  long i, n;
  char name[21];

  cout << "DataBase Filler\n";
  cout << "Enter number of records: ";
  cin >> n;
  cout << "Enter file name: ";
  cin >> name;

  ofstream out(name);
  out << "|----------------------------------------------------------------------------|\n";
  out << "|                             DATABASE \"COMPUTERS\"                           |\n";
  out << "|----------------------------------------------------------------------------|\n\n";

  out.width(5);
  out << "N";
  out.width(20);
  out << "Processor type";
  out.width(7);
  out << "Speed";
  out.width(7);
  out << "Mem";
  out.width(7);
  out << "HDD";
  out.width(20);
  out << "Video adapter";
  out.width(7);
  out << "Price";
  out.width(0);
  out << "\n-----------------------------------------------------------------------------";
  for (i = 0; i < n; i++)
  {
    Generate();
  out << "\n";
  out.width(5);
  out << i + 1;
  out.width(20);
  out << r.processor;
  out.width(7);
  out << r.speed;
  out.width(7);
  out << r.memory;
  out.width(7);
  out << r.HDD;
  out.width(20);
  out << r.video;
  out.width(7);
  out << r.price;
  }

  out.close();
}
